using System;
class HelloWorld 
{
    static void Main() 
    {
        string[] s = Console.ReadLine().Split(' ');
        int n = int.Parse(s[0]);
        int m = int.Parse(s[1]);
        int[,] a = new int[n,3];
        for(int i = 0; i < m; i++)
        {
            s = Console.ReadLine().Split(' ');
            for(int j = 0; j < 3; j++)
            {
                a[i,j] = int.Parse(s[j]);
            }
        }
        s = Console.ReadLine().Split(' ');
        int x = int.Parse(s[0]);
        int y = int.Parse(s[1]);
        
        Console.WriteLine(-1);
    }
}